Unit ASK3C_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, AR01C_p, AR02C_p, ASG1C_p;

procedure ASK3C(var A :Array of Complex; var X :Array of Complex;
                var R :Array of Complex; M :Integer;
                L :Integer);

implementation

procedure ASK3C(var A :Array of Complex; var X :Array of Complex;
                var R :Array of Complex; M :Integer;
                L :Integer);
var
I,J,MM,_i :Integer;
PII,RL :Real;
_iar :Array of Integer;
const
SYS003 :Real = 6.2831853071795864769252867665590;
label
_1,_2;
begin
 SetLength(_iar,High(R)+1);  //   
{  ****************************************************************** C }
{                                                                     C }
{  ------------------------  HAHAEHE  ---------------------------- C }
{                                                                     C }
{       PEEHE CCTEM HEHX AEPAECKX YPABHEH  A X = B    C }
{       C KETOHO-PKYHTHO MATPE , BCE KETK KOTOPO CYT    C }
{       MATP OEO BA (T.E. A - BYXYPOBHEBA MATPA CG-TA). C }
{                                                                     C }
{       OPOHOE OCAHE :                                          C }
{       ( 1 ) E.E.TPTHKOB , O PEEH CCTEM C MATPAM TA     C }
{       TEEBX , B C. CEHH AHA HA OPTPAHE               C }
{       ( BCTEHE METO  HCTPYMEHTAHE CCTEM ) ,        C }
{       -BO MY , 1978 .                                           C }
{                                                                     C }
{                                                                     C }
{  ---------------------------  METO  ------------------------------ C }
{                                                                     C }
{       MATPA  A  KETOHOO PAMEPA  L * L , C KETKAM PAMEPA    C }
{       M * M , OOHM PEOPAOBAHEM PBOTC K KETOHO-       C }
{       AOHAHO MATPE TEX E PAMEPOB . TEM CAMM PEEHE      C }
{       CXOHO CCTEM OPKA M * L  CBEEHO K PEEH   L         C }
{       CCTEM OPKA  M .                                           C }
{                                                                     C }
{                                                                     C }
{  ------------------  K  POPAMMPOBAH  ---------------------- C }
{                                                                     C }
{       OPTPAH                                                       C }
{                                                                     C }
{                                                                     C }
{  -----------------  OPAHA - PAPAOTK  -------------------- C }
{                                                                     C }
{       HAYHO - CCEOBATECK BCTEH EHTP  M  Y ,      C }
{       AOPATOP  CEHHOO  AHAA                              C }
{                                                                     C }
{       APEC :                                                       C }
{       MOCKBA ,117234 , HB MY , AOPATOP CEHHOO AHAA    C }
{                                                                     C }
{  -----------------------  COOBAHE  -------------------------- C }
{                                                                     C }
{       CALL ASK3C(A,X,R,M,L)                                         C }
{                                                                     C }
{  -------------------------  APAMETP  ---------------------------- C }
{                                                                     C }
{       A - KOMEKCH OHOMEPH MACCB H  M * M * L , B        C }
{           KOTOPOM AAETC MATPA CCTEM COACHO PABAM ,      C }
{           AHHM B  ( 1 ) . A MEHHO : MACCB  A  ETC HA  L     C }
{           KYCKOB H  M * M . B  I-OM KYCKE ACBAETC I-A     C }
{           KETKA EPBO KETOHO CTPOK CXOHO MATP , KAK     C }
{           OHO , O CTOAM .                                    C }
{                                                                     C }
{       X - KOMEKCH OHOMEPH MACCB H  M * L , B KOTOPOM    C }
{           AAETC PABA ACT . HA BXOE OPOPAMM B  X       C }
{           OYAETC PEEHE .                                      C }
{                                                                     C }
{       R - KOMEKCH OHOMEPH PAO MACCB H MAX(Q,L) ,    C }
{           E  Q - EA ACT CA  ( M+1 ) / 2  .                C }
{                                                                     C }
{       M - OPOK 2 - O YPOBH . T : E.                      C }
{                                                                     C }
{       L - OPOK 1 - O YPOBH . T : E.                      C }
{                                                                     C }
{                                                                     C }
{  -----------------  BBAEME  OPOPAMM  --------------------- C }
{                                                                     C }
{       AR01C , AR02C , ASG1C                                         C }
{                                                                     C }
{  ****************************************************************** C }
{                                                                     C }
{                                                                     C }
{                                                                     C }
{                                                                     C }
{  -------------------------  KOHCTAHT  ---------------------------- C }

{       SIS003=6.2831853717958647692528 (2*) }


PII := SYS003/L;
MM := M*M;

AR01C(A,R,MM,L,PII);

AR02C(X,R,M,L,PII);

for I:=1 to L do
 begin
_1:
//  ASG1C(A[0+0*M+(I-1)*M*M],X[0+(I-1)*M],X[0+(I-1)*M],R,M,1);
  ASG1C(A[0+0*M+(I-1)*M*M],X[0+(I-1)*M],X[0+(I-1)*M],_iar,M,1);
 end;

AR01C(X,R,M,L,PII);

RL := 1.0/L;
for J:=1 to L do
 begin
  for I:=1 to M do
   begin
_2:
    X[(I-1)+(J-1)*M] := MulC(X[(I-1)+(J-1)*M],Cmplx(RL,0.0));
   end;
 end;

end;

end.
